* get_cursor_log
local array af[1]
local fc,i,fd,cpath,fn,priznak,FileSize,nID
select sources
scan for nuse > 0
	m.priznak = .t.
	m.cpath = addbs(alltrim(pathlog))
	m.nID = id && ID 
	if is_directory(m.cpath)
		m.fc = adir(m.af, m.cpath + "access.log.*")	
		for m.i = 1 to m.fc
			m.fn = m.cpath + m.af[m.i,1]
			m.FileSize = GetFileSize(m.fn)
			m.fd = fopen(m.fn)
			if m.fd > -1
				if m.FileSize > 0
					get_statistic(m.fd,m.nID,m.FileSize,m.fn)
				else
					write_into_log(' '+ m.fn + '  0 ')
				endif
			else
				write_into_log('   ' + m.fn)
			endif
			fclose(m.fd)
			
		endfor
	else
		replace sources.nuse with 0 in sources
	endif
	select sources
endscan
if !m.priznak
	write_into_log('      ')
endif

*    
if Options.useold > 0
	local srok
	m.srok = Options.srokold
	delete from squidlog where date() - ttod(timestamp) > m.srok
	pack in squidlog
endif
return

function get_statistic
lparameters fd , ds , FileSize , fn
local cID , FullUrl , cProtocol , cHost , cPort , cExt
local s, aSize , ps , readln , glt , r_newcount , r_oldcount , ts0 , cAction
local L0,Pos
local array p[14] , pm[4]
	write_into_log('  ' + m.fn)
	if empty(_screen.AdminKey)
		m.ps = createobject('progressbar',m.fn)
		m.ps.show()
	endif
	m.readln = 0
	m.r_oldcount = reccount('squidlog')	
	m.ts0 = datetime(1970,1,1,GetTZI())
	create_test_import() &&        
	t1 = seconds()
	do while !feof(m.fd)
		m.s = fread(m.fd,65535) &&  
		m.L0 = len(m.s) &&   
		pos = rat(chr(13),m.s,1) &&  1    
		m.s = left(m.s,m.pos-1) &&    
		fseek(m.fd,m.pos-m.L0+1,1) &&      
		Parse_Sring(m.ds,m.s,m.ts0) &&     S !!!
		m.readln = m.readln + len(m.s) + 2
		if empty(_screen.AdminKey)
			ps.currentvalue = round(m.readln/m.FileSize*100,0)
		endif
	enddo
	index_test_import() &&  test_import
	sum12table() &&    
	GetResultImport()
	t2 = seconds()
	m.r_newcount = reccount('squidlog')
	write_into_log('  '+transform(m.r_newcount - m.r_oldcount))
	write_into_log('  () ' + transform(t2-t1))
	write_into_log('  ' + m.fn)
	*          ID 
	*       
	* messagebox(ttoc(m.ts_min)+'   '+ttoc(m.ts_max))
	*insert into AccessTS (id_source,ts1,ts2) values (m.ds,m.ts_min,m.ts_max)
return

procedure Parse_Sring
lparameters ds,s,ts0
local FullUrl , cProtocol , cHost , cPort , cExt , i , line_count , ts , nTally
local p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15
local array my_s[1] , my_s1[1]
	m.line_count = alines(m.my_s,m.s,chr(13)+chr(10))
	for m.i = 1 to m.line_count
		m.my_s[m.i] = delspace(my_s[m.i])
		alines(m.my_s1,m.my_s[m.i],' ')
		m.FullUrl = m.my_s1[7]
		parse_url(m.FullUrl , @cProtocol , @cHost , @cPort , @cExt)
		m.p0 = sys(2015)				&& id	
		m.p1 = val(m.my_s1[1]) + m.ts0 	&& timestamp
		m.p2 = val(m.my_s1[2])
		m.p3 = m.my_s1[3]				&& IP
		m.p4 = getwordnum(m.my_s1[4],1,'/')
		m.p5 = val(m.my_s1[5])			&& Size
		m.p6 = m.my_s1[6]
		m.p7 = m.fullurl				&& URL
		m.p8 = m.my_s1[8]				&& Ident
		m.p9 = getid(getwordnum(m.my_s1[9],1,'/'),'hierars') && getwordnum(m.my_s1[9],1,'/') && hierar
		m.p10 = getid(m.my_s1[10],'contents') && m.my_s1[10] &&   Squid Native 30-MIME
		m.p11 = val(getwordnum(m.my_s1[4],2,'/'))
		m.p12 = m.cHost
		m.p13 = m.ds
		m.p14 = get_idprotocol(m.cProtocol,m.cPort)
		m.p15 = get_idext('.'+m.cExt)
		m.p16 = get_idhostg(m.fullurl)
		insert into test_import ;
			(id,timestamp,elapsed,id_ip,id_action,size,id_method,id_url,id_ident,id_hierar,id_content,kod, ;
				host,id_source,id_prot,id_ext,id_hostg) ;
				values(m.p0,m.p1,m.p2,m.p3,m.p4,m.p5,m.p6,m.p7,m.p8,m.p9,m.p10,m.p11,m.p12,m.p13,m.p14,m.p15,m.p16)
	endfor
return

procedure getid
lparameters cdano, cAlias
	if inlist(upper(alltrim(m.cdano)),'NONE','-') and inlist(lower(m.cAlias),'hierars','contents')
		m.cdano = iif(lower(m.cAlias)='hierars','','')
	endif
	if !seek(m.cdano,m.cAlias,'name')
		insert into (m.cAlias) (name) values(m.cdano)
	endif
return evaluate(m.cAlias+'.id')

procedure getpsevdo
lparameters cdano, cAlias
	if !seek(m.cdano,m.cAlias,'name')
		insert into (m.cAlias) (name,psevdo) values(m.cdano , m.cdano)
	endif
return evaluate(m.cAlias+'.id')


function get_idprotocol
lparameters cProtocol,cPort
local cResult
	m.cResult = iif(empty(m.cPort),m.cProtocol,m.cPort)
	if seek(m.cResult,'protocol1','name')
		m.cResult = protocol1.idparent
	else
		m.cResult = 1
	endif
return m.cResult

function get_idext
lparameters cExt
local cResult
	if seek(m.cExt,'typedata1','name')
		m.cResult = typedata1.idparent
	else
		m.cResult = 1
	endif
return m.cResult

function get_idhostg
lparameters cURL
local cResult
	m.cResult = 1
	select host1
	locate for like("*"+alltrim(name)+"*",m.cURL)
	if found()
		m.cResult = idparent
	endif
return m.cResult

function delspace
lparameters cS
	do case
		case at('      ',m.cS) > 0
			m.cS = strtran(m.cS,'      ',' ')
		case at('     ',m.cS) > 0
			m.cS = strtran(m.cS,'     ',' ')
		case at('    ',m.cS) > 0
			m.cS = strtran(m.cS,'    ',' ')
		case at('   ',m.cS) > 0
			m.cS = strtran(m.cS,'   ',' ')
		case at('  ',m.cS) > 0
			m.cS = strtran(m.cS,'  ',' ')
	endcase
return m.cS

Procedure create_test_import
local lclocalTableName
	m.lclocalTableName = 'test_import'
	create cursor (m.lclocalTableName) ( ;
		id c(10), ;			&&  0   -   
		timestamp t, ;		&&  1 DateTime,   Fox
		elapsed i, ;		&&  2    
		id_ip c(15), ;		&&  3 IP   15
		id_action c(45), ;	&&  4  Squid- 40
		size i, ;			&&  5   
		id_method c(10), ;	&&  6 Get/Post/Connect ... 10
		id_url m, ;			&&  7
		id_ident c(15), ;	&&  8   15
		id_hierar i, ;		&&  9     15
		id_content i, ;		&& 10   Squid Native 30
		kod i, ;			&& 11
		Host c(60), ;		&& 12
		id_source i, ;		&& 13
		id_prot i, ;		&& 14
		id_ext i, ;			&& 15
		id_hostg i)			&& 16
return

procedure index_test_import
	select test_import
	index on id					tag id
	index on transform(id_source)+ttoc(timestamp)			tag stimestamp
	index on id_ip				tag id_ip
	index on id_action			tag id_action
	index on id_method			tag id_method
	index on id_ident			tag id_ident
return

procedure sum12table
	*    
	insert into ippsevdo (name,psevdo) ;
		select distinct a.id_ip as name , a.id_ip as psevdo from test_import as a ;
			where a.id_ip not in (select b.name from ippsevdo as b ) && into cursor ctemp
			
	insert into userpsevdo (name,psevdo) ;
		select distinct a.id_ident as name , a.id_ident as psevdo from test_import as a ;
			where a.id_ident not in (select b.name from userpsevdo as b )
			
	******		
	insert into actions (name) ;
		select distinct a.id_action as name from test_import as a ;
			where a.id_action not in (select b.name from actions as b ) && into cursor ctemp
	
	insert into methods (name) ;
		select distinct a.id_method as name from test_import as a ;
			where a.id_method not in (select b.name from methods as b )	
	
*!*		insert into contents (name) ;
*!*			select distinct a.id_content as name from test_import as a ;
*!*				where a.id_content not in (select b.name from contents as b )
*!*		
*!*		insert into hierars (name) ;
*!*			select distinct a.id_hierar as name from test_import as a ;
*!*				where a.id_hierar not in (select b.name from hierars as b )
return

procedure GetResultImport
	*      
	insert into SquidLog ;
			select ;
				a.id, ;
				a.timestamp, ;
				a.elapsed , ;
				b.id as id_ip, ;
				d.id as id_action, ;
				a.size, ;
				e.id as id_method, ;
				a.host, ;
				c.id as id_ident, ;
				a.id_hierar, ;
				a.id_content, ;
				a.id_source, ;
				a.id_prot, ;
				a.id_ext, ;
				a.id_hostg, ;
				a.kod, ;
				a.id_url as url ;
			from test_import as a ;
				left join ippsevdo as b on a.id_ip = b.name ;
				left join userpsevdo as c on a.id_ident = c.name ;
				left join actions as d on a.id_action = d.name ;
				left join methods as e on a.id_method = e.name ;
			where transform(a.id_source)+ttoc(a.timestamp) not in ;
				(select transform(b.id_source)+ttoc(b.timestamp) as stimestamp from SquidLog as b )
return

