* get_cursor_log
local array af[1]
local fc,i,fd,cpath,fn,priznak,FileSize
select sources
scan for nuse > 0
	m.priznak = .t.
	m.cpath = addbs(alltrim(pathlog))
	if is_directory(m.cpath)
		m.fc = adir(m.af, m.cpath + "access.log.*")	
		for m.i = 1 to m.fc
			m.fn = m.cpath + m.af[m.i,1]
			m.FileSize = GetFileSize(m.fn)
			m.fd = fopen(m.fn)
			if m.fd > -1 and m.FileSize > 0
				get_statistic(m.fd,id,m.FileSize,m.fn)
			else
				write_into_log('   ' + m.fn)
			endif
			fclose(m.fd)
		endfor
	else
		replace sources.nuse with 0 in sources
	endif
	select sources
endscan
if !m.priznak
	write_into_log('      ')
endif

*    
if Options.useold > 0
	local srok
	m.srok = Options.srokold
	delete from squidlog where date() - ttod(timestamp) > m.srok
	pack in squidlog
endif

return

function get_statistic
lparameters fd , ds , FileSize , fn
local cProtocol , cHost , cPort , cExt
local s, aSize , ps , readln , glt , r_newcount , r_oldcount , ts , ts0 , cAction
	m.aSize = 17
local array p[m.aSize]
	write_into_log('  ' + m.fn)
	m.ps = createobject('progressbar',m.fn)
	m.ps.show()
	m.readln = 0
	m.glt = get_last_datetime()
	m.r_oldcount = reccount('squidlog')	
	m.ts0 = datetime(1970,1,1,GetTZI())
	t1 = seconds()
	do while !feof(m.fd)
		m.s = fgets(m.fd,8192)
		alines(arr,s,space(6),space(5),space(4),space(3),space(2),space(1))
		m.ts = m.ts0 + val(getwordnum(m.s,1))
		if m.ts > m.glt
			m.cAction = getwordnum(m.s,4)
			m.p[1]  = sys(2007,m.s,0,1) 					&& 1 ID (  )															
			m.p[2]  = m.ts									&& 2 DateTime (Native FoxPro)			
			m.p[3]  = getwordnum(m.s,2)						&& 3 Elapsed
			m.p[4]  = getwordnum(m.s,5)						&& 4 Size
			m.p[5]  = getwordnum(m.cAction,2,'/')			&& 5  
			m.p[6]  = getwordnum(m.s,3)						&& 6 ip
			m.p[7]  = getwordnum(m.cAction,1,'/')			&& 7  Squid- 40
			m.p[8]  = getwordnum(m.s,6)						&& 8 Get/Post/Connect ... 10
			m.p[9]  = getwordnum(m.s,8)						&& 9 ident
			m.p[10] = getwordnum(getwordnum(m.s,9),1,'/')	&& 10 hierarchy
			m.p[11] = getwordnum(m.s,10)					&& 11   Squid Native 30-MIME
			m.p[m.aSize] = getwordnum(m.s,7)				&& 17  URL
			parse_url(m.p[m.aSize] , @cProtocol , @cHost , @cPort , @cExt)
			m.p[12] = m.cHost								&& 13 id   60
			m.p[13] = m.ds									&& 12 id source ( )
			m.p[14] = get_idprotocol(m.cProtocol,m.cPort)	&& 14 id 
			m.p[15] = get_idext(m.cExt)				&& 15 id   SquidMonitor Native
			m.p[16] = get_idhostg(m.p[m.aSize]) 			&& 16 ID  
			insert into squidlog from array m.p
			addpsevdo(m.p[6],'ippsevdo')
			addpsevdo(m.p[9],'userpsevdo')
		endif
		m.readln = m.readln + len(m.s) + 2
		ps.currentvalue = round(m.readln/m.FileSize*100,0)
	enddo
	t2 = seconds()
	m.r_newcount = reccount('squidlog')
	write_into_log('  '+transform(m.r_newcount - m.r_oldcount))
	write_into_log('  () ' + transform(t2-t1))
	write_into_log('  ' + m.fn)
return

procedure addpsevdo
lparameters cdano, cAlias
	m.cdano = padr(m.cdano,15)
	if !seek(m.cdano,m.cAlias,'name')
		insert into (m.cAlias) (name,psevdo) values(m.cdano , m.cdano)
	endif
return


function get_idprotocol
lparameters cProtocol,cPort
local cResult
	m.cResult = iif(empty(m.cPort),m.cProtocol,m.cPort)
	if seek(m.cResult,'protocol1','name')
		m.cResult = protocol1.idparent
	else
		m.cResult = 1
	endif
return m.cResult

function get_idext
lparameters cExt
local cResult
	if seek(m.cExt,'typedata1','name')
		m.cResult = typedata1.idparent
	else
		m.cResult = 1
	endif
return m.cResult

function get_idhostg
lparameters cURL
local cResult
	m.cResult = 1
	select host1
	locate for like("*"+alltrim(name)+"*",m.cURL)
	if found()
		m.cResult = idparent
	endif
return m.cResult

*!*	function prototype
*!*	lparameters s,s1,s2
*!*	return iif(lower(m.s) = lower(m.s1),m.s2,m.s)

